#ifdef WIN32
#define _CRT_SECURE_NO_WARNINGS
#endif

#include <assert.h>
#include <string.h>

#include "object.h"
#include "xmalloc.h"
#include "match1.h"


int					Cmatch::m_matches_lth = 0;
matchesT *			Cmatch::m_hash[1<<16] = {0};
unsigned short		Cmatch::m_next[1<<16] = {0};
unsigned short		Cmatch::m_first       = 0;

block_matchesT *	Cmatch::m_head_block_matchesP = 0;
block_matchesT *	Cmatch::m_block_matchesP      = 0;
matchesT *	    	Cmatch::m_matches_cacheP      = 0;
matchesT *	        Cmatch::m_matches_endP        = 0;
long long			Cmatch::m_comparisons         = 0;

extern int	g_max_function_lth;

void
Cmatch::init(void)
{
}

void
Cmatch::setup(int lth)
{
}
			
void
Cmatch::add(int offset, void *code2P)
{
	static	block_matchesT	*next_blockP;
	static  unsigned short  hash;

	if (m_matches_cacheP == m_matches_endP) {
		if (m_block_matchesP) {
			next_blockP = m_block_matchesP->m_nextP;
		} else {
			next_blockP = 0;
		}
		if (!next_blockP) {
			next_blockP = (block_matchesT *) Xmalloc(sizeof(block_matchesT));
			if (!next_blockP) {
				outofmemory();
			}
			next_blockP->m_nextP = 0;
			if (m_block_matchesP) {
				m_block_matchesP->m_nextP = next_blockP;
			} else {
				m_head_block_matchesP = next_blockP;
		}	}
		m_block_matchesP = next_blockP;

		m_matches_cacheP = m_block_matchesP->m_cache;
		m_matches_endP   = m_matches_cacheP + 8192;
	}
	hash                       = (unsigned short) (((unsigned int) code2P) ^ (unsigned int) offset);
	m_matches_cacheP->m_offset = offset;
	m_matches_cacheP->m_codeP  = code2P;
	if (!(m_matches_cacheP->m_nextP  = m_hash[hash]) && hash) {
		m_next[hash] = m_first;
		m_first      = hash;
	}
	m_hash[hash] = m_matches_cacheP++;
}

int
Cmatch::test(int offset, void *code2P)
{
	static	unsigned short	hash;
	static	matchesT		*matchesP;

	hash = (unsigned short) (((unsigned int) code2P) ^ (unsigned int) offset);

	for (matchesP = m_hash[hash]; matchesP; matchesP = matchesP->m_nextP) {
		++m_comparisons;
		if (matchesP->m_offset == offset && matchesP->m_codeP == code2P) {
			return(1);
	}	}
	return(0);
}

void
Cmatch::clear(void)
{
	if ((m_block_matchesP = m_head_block_matchesP)) {
		m_matches_cacheP = m_block_matchesP->m_cache;
		m_matches_endP   = m_matches_cacheP + 8192;
	}
	for (; m_first; m_first = m_next[m_first]) {
		assert(m_hash[m_first]);
		m_hash[m_first] = 0;
	}
	m_hash[m_first] = 0;
}
